<?php
namespace Drupal\data_api;

require_once dirname(__FILE__) . '/drupal7_mocks.php';

class DataTest extends \PHPUnit_Framework_TestCase
{
    public function testItemLevel()
    {
        global $entity;
        $subject = array('und' => array(array('value' => 'Scott Johnson')));
        $node = (object) array(
            "field_name" => $subject,
            'type'       => 'person',
        );
        $entity = $node;
        $control = $subject['und'][0]['value'];
        $this->assertSame($control, $this->data->setEntityType('node')
                                               ->get($node, 'field_name.0.value'));
    }
    public function testDeltaLevel()
    {
        global $entity;
        $subject = array('und' => array(array('value' => 'Scott Johnson')));
        $node = (object) array(
            "field_name" => $subject,
            'type'       => 'person',
        );
        $entity = $node;
        $control = $subject['und'][0];
        $this->assertSame($control, $this->data->setEntityType('node')
                                               ->get($node, 'field_name.0'));
    }

    public function testFieldLevel()
    {
        global $entity;
        $subject = array('und' => array(array('value' => 'Scott Johnson')));
        $node = (object) array(
            "field_name" => $subject,
            'type'       => 'person',
        );
        $entity = $node;
        $control = $subject['und'];
        $this->assertSame($control, $this->data->setEntityType('node')
                                               ->get($node, 'field_name'));
    }

    public function testEmptySubject()
    {
        $this->assertSame('froggy', $this->data->get(array(), 'field', 'froggy'));
    }

    public function testNid()
    {
        global $entity;
        $subject = (object) array('nid' => 27);
        $entity = $subject;
        $this->assertSame(27, $this->data->setEntityType('node')
                                         ->get($subject, 'nid'));
    }

    public function testNidNoEntityType()
    {
        global $entity;
        $subject = (object) array('nid' => 27);
        $entity = $subject;
        $this->assertSame(27, $this->data->get($subject, 'nid'));
    }

    public function setUp()
    {
        $this->data = new Data;
    }
}
